<?php

namespace Energik\StoreLocator\Http\Controllers;

use App\Http\Controllers\PublicController as CMSPublicController;
use Energik\StoreLocator\Interfaces\StoreLocatorRepositoryInterface;

class StoreLocatorPublicController extends CMSPublicController
{
    /**
     * Constructor.
     *
     * @param type \Energik\StoreLocator\Interfaces\StoreLocatorRepositoryInterface $store_locator
     *
     * @return type
     */
    public function __construct(StoreLocatorRepositoryInterface $store_locator)
    {
        $this->repository = $store_locator;
        parent::__construct();
    }

    /**
     * Show store_locator's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $store_locators = $this->repository->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('store_locator::public.store_locator.index', compact('store_locators'))->render();
    }

    /**
     * Show store_locator.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $store_locator = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('store_locator::public.store_locator.show', compact('store_locator'))->render();
    }
}
