<?php

namespace Energik\StoreLocator\Repositories\Eloquent;

use Energik\StoreLocator\Interfaces\StoreLocatorRepositoryInterface;
use Litepie\Database\Eloquent\BaseRepository;

class StoreLocatorRepository extends BaseRepository implements StoreLocatorRepositoryInterface
{
    /**
     * @var array
     */
    protected $fieldSearchable = [
        'name'  => 'like'
    ];

    public function boot()
    {
        $this->pushCriteria(app('Litepie\Database\Criteria\RequestCriteria'));
    }

    /**
     * Specify Model class name.
     *
     * @return string
     */
    public function model()
    {
        return config('package.store_locator.store_locator.model');
    }
}
